---
title: WEBGL_draw_buffers
slug: Web/API/WEBGL_draw_buffers
tags:
  - API
  - Reference
  - WebGL
  - WebGL extension
---
<div>{{APIRef("WebGL")}}</div>

<p>The <code><strong>WEBGL_draw_buffers</strong></code> extension is part of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> and enables a fragment shader to write to several textures, which is useful for <a href="https://hacks.mozilla.org/2014/01/webgl-deferred-shading/">deferred shading</a>, for example.</p>

<p>WebGL extensions are available using the {{domxref("WebGLRenderingContext.getExtension()")}} method. For more information, see also <a href="/en-US/docs/Web/API/WebGL_API/Using_Extensions">Using Extensions</a> in the <a href="/en-US/docs/Web/API/WebGL_API/Tutorial">WebGL tutorial</a>.</p>

<div class="note">
<p><strong>Availability:</strong> This extension is only available to {{domxref("WebGLRenderingContext", "WebGL1", "", 1)}} contexts. In {{domxref("WebGL2RenderingContext", "WebGL2", "", 1)}}, the functionality of this extension is available on the WebGL2 context by default. In WebGL 2, the constant<code>s</code> are available without the "WEBGL" suffix and the new GLSL built-ins require GLSL <code>#version 300 es</code>.</p>
</div>

<h2 id="Constants">Constants</h2>

<p>This extension exposes new constants, which can be used in the {{domxref("WebGLRenderingContext.framebufferRenderbuffer()", "gl.framebufferRenderbuffer()")}}, {{domxref("WebGLRenderingContext.framebufferTexture2D()", "gl.framebufferTexture2D()")}}, {{domxref("WebGLRenderingContext.getFramebufferAttachmentParameter()", "gl.getFramebufferAttachmentParameter()")}}  {{domxref("WEBGL_draw_buffers.drawBuffersWEBGL()", "ext.drawBuffersWEBGL()")}}, and {{domxref("WebGLRenderingContext.getParameter()", "gl.getParameter()")}} methods.</p>

<dl>
 <dt><code>ext.COLOR_ATTACHMENT0_WEBGL<br>
 ext.COLOR_ATTACHMENT1_WEBGL<br>
 ext.COLOR_ATTACHMENT2_WEBGL<br>
 ext.COLOR_ATTACHMENT3_WEBGL<br>
 ext.COLOR_ATTACHMENT4_WEBGL<br>
 ext.COLOR_ATTACHMENT5_WEBGL<br>
 ext.COLOR_ATTACHMENT6_WEBGL<br>
 ext.COLOR_ATTACHMENT7_WEBGL<br>
 ext.COLOR_ATTACHMENT8_WEBGL<br>
 ext.COLOR_ATTACHMENT9_WEBGL<br>
 ext.COLOR_ATTACHMENT10_WEBGL<br>
 ext.COLOR_ATTACHMENT11_WEBGL<br>
 ext.COLOR_ATTACHMENT12_WEBGL<br>
 ext.COLOR_ATTACHMENT13_WEBGL<br>
 ext.COLOR_ATTACHMENT14_WEBGL<br>
 ext.COLOR_ATTACHMENT15_WEBGL</code></dt>
 <dd>A {{domxref("GLenum")}} specifying a color buffer.</dd>
 <dt><code>ext.DRAW_BUFFER0_WEBGL<br>
 ext.DRAW_BUFFER1_WEBGL<br>
 ext.DRAW_BUFFER2_WEBGL<br>
 ext.DRAW_BUFFER3_WEBGL<br>
 ext.DRAW_BUFFER4_WEBGL<br>
 ext.DRAW_BUFFER5_WEBGL<br>
 ext.DRAW_BUFFER6_WEBGL<br>
 ext.DRAW_BUFFER7_WEBGL<br>
 ext.DRAW_BUFFER8_WEBGL<br>
 ext.DRAW_BUFFER9_WEBGL<br>
 ext.DRAW_BUFFER10_WEBGL<br>
 ext.DRAW_BUFFER11_WEBGL<br>
 ext.DRAW_BUFFER12_WEBGL<br>
 ext.DRAW_BUFFER13_WEBGL<br>
 ext.DRAW_BUFFER14_WEBGL<br>
 ext.DRAW_BUFFER15_WEBGL</code></dt>
 <dd>A {{domxref("GLenum")}} returning a draw buffer.</dd>
 <dt><code>ext.MAX_COLOR_ATTACHMENTS_WEBGL</code></dt>
 <dd>A {{domxref("GLint")}} indicating the maximum number of framebuffer color attachment points.</dd>
 <dt><code>ext.MAX_DRAW_BUFFERS_WEBGL</code></dt>
 <dd>A {{domxref("GLint")}} indicating the maximum number of draw buffers.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p>This extension exposes one new method.</p>

<dl>
 <dt>{{domxref("WEBGL_draw_buffers.drawBuffersWEBGL()", "ext.drawBuffersWEBGL()")}}</dt>
 <dd>
 <p>Defines the draw buffers to which all fragment colors are written. (When using {{domxref("WebGL2RenderingContext", "WebGL2")}}, this method is available as {{domxref("WebGL2RenderingContext.drawBuffers()", "gl.drawBuffers()")}} by default).</p>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>Enabling the extension:</p>

<pre class="brush: js">var ext = gl.getExtension('WEBGL_draw_buffers');
</pre>

<p>Binding multiple textures (to a <code>tx[]</code> array)  to different framebuffer color attachments:</p>

<pre class="brush: js">var fb = gl.createFramebuffer();
gl.bindFramebuffer(gl.FRAMEBUFFER, fb);
gl.framebufferTexture2D(gl.FRAMEBUFFER, ext.COLOR_ATTACHMENT0_WEBGL, gl.TEXTURE_2D, tx[0], 0);
gl.framebufferTexture2D(gl.FRAMEBUFFER, ext.COLOR_ATTACHMENT1_WEBGL, gl.TEXTURE_2D, tx[1], 0);
gl.framebufferTexture2D(gl.FRAMEBUFFER, ext.COLOR_ATTACHMENT2_WEBGL, gl.TEXTURE_2D, tx[2], 0);
gl.framebufferTexture2D(gl.FRAMEBUFFER, ext.COLOR_ATTACHMENT3_WEBGL, gl.TEXTURE_2D, tx[3], 0);</pre>

<p>Mapping the color attachments to draw buffer slots that the fragment shader will write to using <code>gl_FragData</code>:</p>

<pre class="brush: js">ext.drawBuffersWEBGL([
  ext.COLOR_ATTACHMENT0_WEBGL, // gl_FragData[0]
  ext.COLOR_ATTACHMENT1_WEBGL, // gl_FragData[1]
  ext.COLOR_ATTACHMENT2_WEBGL, // gl_FragData[2]
  ext.COLOR_ATTACHMENT3_WEBGL  // gl_FragData[3]
]);</pre>

<p>Shader code that writes to multiple textures:</p>

<pre class="brush: html">&lt;script type="x-shader/x-fragment"&gt;
#extension GL_EXT_draw_buffers : require

precision highp float;

void main(void) {
  gl_FragData[0] = vec4(0.25);
  gl_FragData[1] = vec4(0.5);
  gl_FragData[2] = vec4(0.75);
  gl_FragData[3] = vec4(1.0);
}
&lt;/script&gt;</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WEBGL_draw_buffers', '', 'WEBGL_draw_buffers')}}</td>
   <td>{{Spec2('WEBGL_draw_buffers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WEBGL_draw_buffers.drawBuffersWEBGL")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.getExtension()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.drawBuffers()")}}</li>
 <li><a href="https://hacks.mozilla.org/2014/01/webgl-deferred-shading/">WebGL deferred shading - Mozilla Hacks blog</a></li>
</ul>
